% $Id: fizadani.cls 28 2011-02-02 12:25:26Z ruzicka $

% Pouv formt LaTeX2e.
\NeedsTeXFormat{LaTeX2e}
% Umon pracovat s SVN metadaty.
\RequirePackage[notoday,nofancy]{svninfo}
% Naten SVN metadat.
\svnInfo $Id: fizadani.cls 28 2011-02-02 12:25:26Z ruzicka $
% Definice makra pro formtovn SVN data modifikace tdy dokumentu.
\def\versioninfo#1-#2-#3{#1/#2/#3}
% Jmno a verze tto tdy dokumentu.
\ProvidesClass{fizadani}[\expandafter\versioninfo\svnInfoDate\space%
                         r\svnInfoRevision] 
% Definice voleb tdy dokumentu.
\DeclareOption*{\PassOptionsToClass{\CurrentOption}{article}}
% Sazba zadn bakalsk prce.
\newif\if@bp
\@bptrue % Vchoz volba.
\DeclareOption{bp}{\@bptrue\@dpoboryfalse\@dpspecializacefalse}
% Sazba zadn diplomov prce -- obory.
\newif\if@dpobory
\@dpoboryfalse
\DeclareOption{dpobory}{\@dpoborytrue\@bpfalse\@dpspecializacefalse}
% Sazba zadn diplomov prce -- specializace.
\newif\if@dpspecializace
\@dpspecializacefalse
\DeclareOption{dpspecializace}{\@dpspecializacetrue\@bpfalse\@dpoboryfalse}
% Nastaven rozlien sazby.
\newcounter{@dpi}
\setcounter{@dpi}{1200} % Vchoz rozlien je 1200 DPI.
\DeclareOption{300dpi}{\setcounter{@dpi}{300}}
\DeclareOption{600dpi}{\setcounter{@dpi}{600}}
\DeclareOption{1200dpi}{\setcounter{@dpi}{1200}}
% Zpracovn voleb tdy dokumentu.
\ProcessOptions

\LoadClass[11pt,a4paper,oneside]{article} % Naten tdy dokumentu article s
                              % pouitm 11bodovho zkladnho psma, formtem
                              % papru A4 a jednostrann sazby jako zkladu tto
                              % tdy dokumentu.
\RequirePackage{ifpdf} % Umon testovat, zda je pekldno do PDF, anebo do 
                       % DVI.
\ifpdf % Pokud se pekld do PDF...
    \usepackage[resetfonts]{cmap} % U podporovanch font zajist ve vslednm 
                                  % PDF sprvn namapovn nrodnch znak do 
                                  % Unicode.
\fi % Konec vhradn sekce pro peklad do PDF.
% Nastaven font.
\RequirePackage{mathpazo} % Jako zklad pout rodinu psem Pazo Math, kter 
                          % obsahuje matematick ezy vhodn pro kombinovn 
                          % s psmem Palatino.
\RequirePackage{tgpagella} % Patkov psmo penastavit na TeX Gyre Pagella (jako 
                           % alternativu psma Palatino).
\RequirePackage{tgheros} % Bezpatkov psmo penastavit na TeX Gyre Heros (jako 
                         % alternativu psma Helvetica).
\RequirePackage{tgcursor} % Strojopisn psmo penastavit na TeX Gyre Cursor 
                          % (jako alternativu psma Courier).
\RequirePackage[hmargin=30truemm,
                tmargin=30truemm,
                bmargin=50truemm,
                ignoreall,
                heightrounded,
               ]{geometry} % Nastaven oblasti sazby na strnce.

\ifpdf % Pokud se pekld do PDF...
    \pdfpkresolution=\value{@dpi} % Rastrov pk fonty do vstupnho PDF vkldat
                                  % ve zvolenm rozlien.
    \RequirePackage[protrusion,expansion,step=1]{microtype} % Aktivuje
                                  % zavovn interpunkce a expanzi font pi
                                  % pekladu pdf(cs)latexem.
    \RequirePackage[pdftex=true,
                    unicode=true,
                    plainpages=false,
                    pdfpagelabels=true,
                    pdfborder={0 0 0},
                    pdfpagemode=UseNone,
                    pdfstartview={XYZ null null 1},
                    pdfpagelayout=OneColumn,
                    pdfdisplaydoctitle=true,
                    bookmarks=true,
                    bookmarksopen=true,
                    bookmarksopenlevel=1,
                    bookmarksnumbered=true
                   ]{hyperref} % Podpora hypertextovch odkaz v dokumentu.
                               % Balk by ml bt pidan a jako posledn,
                               % protoe redefinuje vt mnostv zkladn
                               % pkaz a mohlo by tak dochzet ke konfliktm s
                               % jinmi balky.
\else % Pokud se nepekld do PDF...
    \RequirePackage[protrusion]{microtype} % Aktivuje zavovn interpunkce pi
                                           % pekladu (cs)latexem.
    \RequirePackage[dvips=true,
                    unicode=true,
                   ]{hyperref} % Podpora hypertextovch odkaz v dokumentu.
                               % Balk by ml bt pidan a jako posledn,
                               % protoe redefinuje vt mnostv zkladn
                               % pkaz a mohlo by tak dochzet ke konfliktm s
                               % jinmi balky.
\fi

% Definice pkaz pro optimalizaci zlom.
\newcommand{\vhodnyzlom}{\penalty-5000}
\newcommand{\nevhodnyzlom}{\penalty5000}

% Definice pkaz pro plnn pol formule.
\newcommand{\datum}[1]{\def\@datum{#1}}
\newcommand{\student}[1]{\def\@student{#1}}
\newcommand{\program}[1]{\def\@program{#1}}
\newcommand{\vedouciprace}[1]{\def\@vedouciprace{#1}}
\newcommand{\nazevprace}[1]{\def\@nazevprace{#1}}
\newcommand{\zadaniprace}[1]{\def\@zadaniprace{#1}}
\newcommand{\zakladniliteratura}[1]{\def\@zakladniliteratura{#1}}
\newcommand{\bpobor}[1]{\def\@bpobor{#1}}
\newcommand{\bppracovistevedouciho}[1]{\def\@bppracovistevedouciho{#1}}
\newcommand{\dpoobor}[1]{\def\@dpoobor{#1}}
\newcommand{\dpogarantoboru}[1]{\def\@dpogarantoboru{#1}}
\newcommand{\dpsspecializace}[1]{\def\@dpsspecializace{#1}}
\newcommand{\dpsgarantspecializace}[1]{\def\@dpsgarantspecializace{#1}}

% Vchoz naplnn pol formule.
\datum{\today}
\student{Jm\'eno studenta}
\program{Studovan\'y program}
\vedouciprace{Jm\'eno vedouc\'\i ho pr\'ace}
\nazevprace{Cel\'y n\'azev z\'av\v ere\v cn\'e pr\'ace}
\zadaniprace{Cel\'e zad\'an\'\i{} z\'av\v ere\v cn\'e pr\'ace.}
\zakladniliteratura{Seznam z\'akladn\'\i{} literatury}
\bpobor{Studovan\'y obor}
\bppracovistevedouciho{Katedra (pracovi\v st\v e) vedouc\'\i ho pr\'ace}
\dpoobor{Studovan\'y obor}
\dpogarantoboru{Jm\'eno garanta oboru}
\dpsspecializace{Zvolen\'a specializace (neuv\'ad\'\i{} se, jestli\v ze si
                 student nevol\'\i{} \v z\'adnou specializaci)}
\dpsgarantspecializace{Jm\'eno garanta oboru nebo (jestli\v ze student
                       nevol\'\i{} \v z\'adnou specializaci) oboru}

% Definice pkaz pro vloen loga FI.
\newfont{\filogo}{fi-logo\arabic{@dpi} at 20truemm} % Definice novho fontu s
                               % tahy loga FI MU. Vka znak je zmenena na 
                               % 20 mm.
\newcommand{\logo}{{\filogo SL}} % Definice pkazu pro vysazen loga FI MU
                                 % vloenm nkolika znak ze specilnho fontu.

% Definice psma pro poloky formule.
\newcommand{\textsb}{\small\bfseries}

% Definice pkazu pro sazbu kolonky formule.
\newcommand{\kolonka}[1]{{\textsb #1:}\hspace{1ex}}

% Definice pkaz pro sazbu zarovnanch kolonek formule.
\newlength{\@sirkanejvetsikolonky}
\newlength{\@sirkakolonky}
\newlength{\@rozdilsirky}
\newcommand{\polozka}[2]{%
    \settowidth{\@sirkanejvetsikolonky}{%
        \kolonka{Katedra (pracovi\v st\v e)}%
    }%
    \settowidth{\@sirkakolonky}{\kolonka{#1}}%
    \setlength{\@rozdilsirky}{\@sirkanejvetsikolonky}%
    \addtolength{\@rozdilsirky}{-\@sirkakolonky}%
    \everypar{%
        \leftskip\@sirkanejvetsikolonky%
    }%
    \hangafter1%
    \hangindent\@sirkanejvetsikolonky%
    \vskip1ex%
    {\selectfont\kolonka{#1}}\hspace{\@rozdilsirky}%
    \setlength{\parindent}{1em}%
    #2\par%
    \everypar{}%
    \setlength{\parindent}{0em}%
    \leftskip0em%
    \par%
}

% Definice pkazu pro sazbu podpisovch pol.
\newcommand{\podpis}[1]{%
    \parbox[t]{0.25\textwidth}{\centering\textsb\hrulefill\par #1}
}

% Definice hlaviky formule.
\newcommand{\hlavicka}{%
    \logo\hfill%
    \begin{tabular}{l}%
         {\Large\scshape Masarykova universita}\\[0.5ex]%
         {\Large\scshape Fakulta informatiky}%
    \end{tabular}%
    \bigskip%
    \hrule%
    \bigskip%
    \begin{center}%
        {\Large\bfseries ZAD\'AN\'I{} %
                         \if@bp BAKAL\'A\v RSK\'E\else DIPLOMOV\'E\fi{} %
                         PR\'ACE}%
    \end{center}%
    \bigskip%
    \hfill\kolonka{Datum}\@datum%
    \medskip%
}

% Definice poloek formule.
\newcommand{\polozky}{%
    \polozka{Student(ka)}{\@student}\nopagebreak%
    \polozka{Program}{\@program}\nopagebreak%
    \if@bp%
        \polozka{Obor}{\@bpobor}\nopagebreak%
    \fi%
    \if@dpobory%
        \polozka{Obor}{\@dpoobor}\nopagebreak%
    \fi%
    \if@dpspecializace%
        \polozka{Specializace}{\@dpsspecializace}\nopagebreak%
    \fi%
    \vskip1ex%
    \if@dpobory%
        \polozka{Garant oboru}{\@dpogarantoboru}\nopagebreak%
    \fi
    \if@dpspecializace%
        \polozka{Garant specializace}{\@dpsgarantspecializace}\nopagebreak%
    \fi
    \polozka{Vedouc\'\i{} pr\'ace}{\@vedouciprace}\nopagebreak%
    \if@bp
        \polozka{Katedra (pracovi\v st\v e)}{\@bppracovistevedouciho}\nopagebreak%
    \fi
    \vskip1ex%
    \polozka{N\'azev pr\'ace}{\@nazevprace}\nopagebreak%
    \polozka{Zad\'an\'\i}{\@zadaniprace}%
    \polozka{Z\'akladn\'\i{} literatura}{\@zakladniliteratura}\nopagebreak%
}

% Definice patiky formule.
\newcommand{\paticka}{%
    \vfill%
    \vskip0.025\textheight%
    {\textsb Souhlas se zad\'an\'\i m (podpis, datum)}\nopagebreak
    \vskip0.075\textheight

    \podpis{student(ka)}\hfill
    \podpis{%
        vedouc\'\i\vhodnyzlom{} \if@bp bakal\'a\v rsk\'e\else diplomov\'e\fi\nevhodnyzlom{} pr\'ace%
    }\hfill
    \if@bp%
        \podpis{%
            vedouc\'\i\vhodnyzlom{} odpov\v edn\'eho\nevhodnyzlom{} %
            pracovi\v st\v e%
        }%
    \fi
    \if@dpobory%
        \podpis{%
            garant oboru%
        }%
    \fi
    \if@dpspecializace%
        \podpis{%
            garant\nevhodnyzlom{}  specializace\vhodnyzlom{} (oboru)%
        }%
    \fi
    \par
}

% Definice pkazu pro sestaven a vyszen celho formule.
\newcommand{\makeform}{

    \cleardoublepage % Sazbu zat na nov lich strnce.
    \pagestyle{empty} % dn zhlav a zpat.
    \setlength{\parindent}{0pt} % Nepouvat odstavcovou odrku.

    \hlavicka % Vyszej hlaviku.

    \polozky % Vyszej vechny poloky formule.

    \paticka % Vyszej patiku

    \clearpage % Pipadnou dal sazbu za formulem zat a na dal strnce.
}

% Nastaven PDF metadat.
\ifpdf % Pokud se pekld do PDF...
    \AtBeginDocument{%
        \hypersetup{%
            pdfauthor={\@student},
            pdftitle={Zad\'an\'\i{} \if@bp bakal\'a\v rsk\'e\else 
                      diplomov\'e\fi{} pr\'ace},
            pdfsubject={Ofici\'aln\'\i{} zad\'an\'\i{} 
                        \if@bp bakal\'a\v rsk\'e\else diplomov\'e\fi{}
                        pr\'ace},
            pdfkeywords={z\'av\v ere\v cn\'a pr\'ace; 
                         \if@bp bakal\'a\v rsk\'e\else diplomov\'e\fi{} pr\'ace; 
                         zad\'an\'\i; 
                         ofici\'aln\'\i{} zad\'an\'\i}
    }} % Nastaven metadat pro PDF soubor.
\fi % Konec podmnn sekce.

\endinput
